; #########################################################################

;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib

; #########################################################################

        ;=================
        ; Local prototypes
        ;=================
        WndProc          PROTO :DWORD,:DWORD,:DWORD,:DWORD
        WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
        AboutProc	 PROTO :DWORD,:DWORD,:DWORD,:DWORD
        TopXY	 PROTO :DWORD,:DWORD
        
        wsprintfA PROTO C :DWORD,:VARARG
        wsprintf equ <wsprintfA>

      ;=============
      ; Local macros
      ;=============


      m2m MACRO M1, M2
        push M2
        pop  M1
      ENDM

      return MACRO arg
        mov eax, arg
        ret
      ENDM

; ------------------------------------------------------------
; Macro for nesting function calls in other invoke statements
; ------------------------------------------------------------

      FUNC MACRO parameters:VARARG
        invoke parameters
        EXITM <eax>
      ENDM


      DisplayWindow MACRO handl, ShowStyle
        invoke ShowWindow,handl, ShowStyle
        invoke UpdateWindow,handl
      ENDM

    ; --------------------------------------------
    ; equates to use directly in the message loop
    ; --------------------------------------------
        m_hWnd   equ <msg.hwnd>
        m_Msg    equ <msg.message>
        m_wParam equ <msg.wParam>
        m_lParam equ <msg.lParam>

    ; ---------------------------------------------------------------------------
    ;        -   		;
    ; hMenu -  						;
    ; Ch_Un -    (  )			;
    ; IDMenu - <1300, 1302, 1304>   (  - )	;
    ; ---------------------------------------------------------------------------
    
      CheckMIGroup MACRO hMenu, Ch_Un, IDMenu
      	IRP ID, <IDMenu>
      	  invoke CheckMenuItem, hMenu, ID,Ch_Un or MF_BYCOMMAND
      	ENDM
      ENDM


    .data
        szDisplayName db "WM_ERASEBKGND",0
        DlgAbout db "IDD_DIALOG",0
        szClassName db "CLASS32",0
        About db "     (Chib777)",13,10
              db " ",13,10                 
              db "chib_odessa@ua.fm",13,10
              db "chib_odessa@mail.ru",13,10
              db " ",13,10              
              db "   WM_ERASEBKGND       ",13,10
              db "  ,     ",13,10
              db "    .",13,10
              db "  :",13,10
              db " wParam      ",13,10               
              db " .",13,10
              db "      WNDCLASSEX - hbrBackground",13,10              
              db "   NULL.     .",13,10
              db "      ,   ",13,10
              db "    NULL (.   ABOUT).) ",13,10
              db "         ",13,10
              db " TRUE,   FALSE",13,10
              db " ",13,10
              db "       ",13,10 
              db "  http://www.wasm.ru",13,10              
              db "    ",13,10 
              db " http://www.wasm.ru Edmondu",13,10              
              db " ",13,10
              db " ",13,10                                          
              db "30//09//2003",0             
                        
    .data?
        hInstance dd ?
        CommandLine dd ?
        hIcon dd ?
        hCursor dd ?
        sWid dd ?
        sHgt dd ?
        hWnd dd ?
        hBrush dd ?
        hBrush1 dd ?
        hBrush2 dd ?
        hBrush3 dd ?
        hBrush4 dd ?
        hBrush5 dd ?
        hBrush6 dd ?
        hBrush7 dd ?
        hBrush8 dd ?
        hBrush9 dd ?
        hBrush10 dd ?        
        hMenu dd ?
        hEdit1 dd ?